<?php

// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Module: ContentExpress
// Copyright (C) 2004 by the Content Express Development Team.
//                           Arising Group, Inc.
// http://www.widgetbox.net/
// http://www.xexpress.org
// Original Author of file: Brave Cobra
// Purpose of file:  XMLExpress class
// ----------------------------------------------------------------------

$ModName = basename( dirname( dirname( __FILE__ )));

class XMLExpress extends BaseExpress
{
	function pntables(&$pntable)
	{
    		if (CommonExpress_checkxslt())
		{
			$xmlitems = pnConfigGetVar('prefix')."_ce_xmlitems";
			$pntable['ce_xmlitems'] = $xmlitems;
			$pntable['ce_xmlitems_column']=array(
				'id' =>$xmlitems.'.mc_id',
				'parent_id'         => $xmlitems . '.mc_parent_id',
				'title' => $xmlitems.'.mc_title',
				'content' => $xmlitems.'.mc_content',
				'type' => $xmlitems.'.mc_type',
				'language' => $xmlitems.'.mc_language',
				'status'            => $xmlitems . '.mc_status',
            	'xslt'=> $xmlitems.'.mc_xslt');
		}
	}

	function init($dbconn)	
	{
		global $pnconfig;
		
		if (CommonExpress_checkxslt()){
			$pntable = pnDBGetTables();

			$dbtype = pnConfigGetVar('dbtype');
			$xmlitems_table = $pntable['ce_xmlitems'];
			$xmlitems_column = &$pntable['ce_xmlitems_column'];

			switch ($dbtype){
				case "oci8":
					$sql  = "CREATE TABLE $xmlitems_table (";
					$sql .= substr_replace($xmlitems_column[id],'',0,strlen($xmlitems_table)+1) ." NUMBER(11,0) NOT NULL ,";
					$sql .= substr_replace($xmlitems_column[parent_id],'',0,strlen($xmlitems_table)+1) ." NUMBER(11,0) default '-1' NOT NULL ,";
					$sql .= substr_replace($xmlitems_column[title],'',0,strlen($xmlitems_table)+1) ." VARCHAR2(30),";
					$sql .= substr_replace($xmlitems_column[content],'',0,strlen($xmlitems_table)+1) ." CLOB NULL ,";
					$sql .= substr_replace($xmlitems_column[type],'',0,strlen($xmlitems_table)+1) ." NUMBER(4,0) default '1' NOT NULL ,";
					$sql .= substr_replace($xmlitems_column[language],'',0,strlen($xmlitems_table)+1) ." varchar2(30) NOT NULL ,";
					$sql .= substr_replace($xmlitems_column[status],'',0,strlen($xmlitems_table)+1) ." NUMBER(4,0) default '1' NOT NULL ,";
					$sql .= substr_replace($xmlitems_column[xslt],'',0,strlen($xmlitems_table)+1) ." NUMBER(11,0) default '1' NOT NULL ,";
					$sql .= "CONSTRAINT ".substr_replace($xmlitems_column[id],'',0,strlen($xmlitems_table)+1) ." PRIMARY KEY (".substr_replace($xmlitems_column[id],'',0,strlen($xmlitems_table)+1) ."))";;
				
					$dbconn->Execute($sql);

					if ($dbconn->ErrorNo() != 0) {
						pnSessionSetVar('errormsg', _CREATETABLEFAILED ." - $xmlitems_table");
						return false;
					}
	
					break;
				default:
				$sql  = "CREATE TABLE $xmlitems_table (";
				$sql .= "$xmlitems_column[id] int(11) NOT NULL auto_increment, ";
				$sql .= "$xmlitems_column[parent_id] int(11) NOT NULL default -1, ";
				$sql .= "$xmlitems_column[title] varchar(30) NOT NULL, ";
				$sql .= "$xmlitems_column[content] longtext NOT NULL, ";
				$sql .= "$xmlitems_column[type] tinyint(4) NOT NULL default '1', ";
				$sql .= "$xmlitems_column[language] varchar(30) NOT NULL, ";
				$sql .= "$xmlitems_column[status] tinyint(4) NOT NULL default '1', ";
				$sql .= "$xmlitems_column[xslt] int(11) NOT NULL default '1', ";
				$sql .= "PRIMARY KEY (mc_id))";
	
				$dbconn->Execute($sql);

				if ($dbconn->ErrorNo() != 0) {
					pnSessionSetVar('errormsg', _CREATETABLEFAILED ." - $xmlitems_table");
					return false;
				}
				break;
			}

			pnModSetVar('ContentExpress', 'xml_directory', $xml_directory);

			return true;
			}
		return true;
	}

	function upgrade($oldversion)
	{
		if (CommonExpress_checkxslt()){
			list($dbconn) = pnDBGetConn();
			$pntable = pnDBGetTables();

			switch($oldversion) {
				case "1.2.7.4":
                	$xmlitems_table = pnConfigGetVar('prefix') . '_ce_xmlitems';
					$sql = "ALTER TABLE $xmlitems_table
                        ADD mc_title varchar(30) NOT NULL AFTER mc_parent_id";
					$dbconn->Execute($sql);
                	if ($dbconn->ErrorNo() != 0) {
                    	pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - add title field $xmlitems_table");
                    	return false;
                	}
				break;
			}
		return true;
		}
	return true;
	}

	function remove()
	{
		if (CommonExpress_checkxslt()){
			list($dbconn) = pnDBGetConn();
			$pntable = pnDBGetTables();

			$sql = "DROP TABLE $pntable[ce_xmlitems]";
			$dbconn->Execute($sql);

			if ($dbconn->ErrorNo() != 0) {
				pnSessionSetVar('errormsg', _DELETETABLEFAILED ." - $pntable[ce_contentitems]");
				return false;
			}
        	pnModDelVar('ContentExpress', 'xml_directory');

			return true;
		}
		return true;
	}

	function version( &$modversion )
	{
		$modversion['name'] = 'ContentExpress';
		$modversion['version'] = '1.2.7.5';
		$modversion['description'] = 'Content Management Module';
		$modversion['credits'] = 'docs/credits.txt';
		$modversion['help'] = 'docs/help.txt';
		$modversion['changelog'] = 'docs/changelog.txt';
		$modversion['license'] = 'docs/license.txt';
		$modversion['official'] = 0;
		$modversion['author'] = 'Chester Chee, Brave Cobra, Jorn Lind-Nielsen';
		$modversion['contact'] = 'http://www.xexpress.org/';
		$modversion['admin'] = 1;
		$modversion['securityschema'] = array('ContentExpress::XML' => 'XML ID::');
	}

	function api_get($args)
	{
		extract($args);

		$items = array();

		if (!pnSecAuthAction(0, 'ContentExpress::XML', '::', ACCESS_READ)) {
			return $items;
		}
		$dbtype = pnConfigGetVar('dbtype');
		list($dbconn) = pnDBGetConn();
		$pntable = pnDBGetTables();
		
		$xmlitems_table = $pntable['ce_xmlitems'];
		$xmlitems_column = &$pntable['ce_xmlitems_column'];

		$sql  = "SELECT $xmlitems_column[id], ";
		$sql .= "       $xmlitems_column[parent_id], ";
		$sql .= "       $xmlitems_column[title], ";
		$sql .= "       $xmlitems_column[content], ";
		$sql .= "       $xmlitems_column[type], ";
		$sql .= "       $xmlitems_column[language], ";
		$sql .= "       $xmlitems_column[status], ";
		$sql .= "       $xmlitems_column[xslt] ";
		$sql .= "FROM $xmlitems_table ";
		$sql .= "WHERE 1";
		$sql .= " AND ($xmlitems_column[id] = $xmlid);";

		/*
		// If current status is provided, then use it to restrict result set
		if ( $modulemode <> "adminparentselect"){
		*/
		if( isset( $status ) && !empty( $status )) 
		{
			$sql .= " AND $xmlitems_column[status] = ".pnVarPrepForStore($status);
		}

		if( isset( $xslt ) && !empty( $xslt )) 
		{
			$sql .= " AND $xmlitems_column[xslt] = ".pnVarPrepForStore($xslt);
		}
		/*
		$sql .= " ORDER BY $menuitems_column[block_id], ";
		$sql .= "        $menuitems_column[parent_id], ";*/
		$result = $dbconn->Execute($sql);

		if ($dbconn->ErrorNo() != 0) {
			return $item;
		}
		list($id, $parent_id, $title, $content, $type, $language, $status,$xslt) = $result->fields;

		if( pnSecAuthAction( 0, 'ContentExpress::XML', "$xmlid::", ACCESS_READ )) {
			$item = array('id' => $id,
				'parent_id' => $parent_id,
				'title' => $title,
				'content' => $content,
				'type'=>$type,
				'language' => $language,
				'status' => $status,
				'xslt'=>$xslt);
		}
		$result->Close();
		return $item;
	}

	function api_getxslt($args)
	{
		extract($args);
		$items = array();

		if (!pnSecAuthAction(0, 'ContentExpress::XML', '::', ACCESS_READ)) 
		{
			return $items;
		}
		$dbtype = pnConfigGetVar('dbtype');
		list($dbconn) = pnDBGetConn();
		$pntable = pnDBGetTables();

		$xmlitems_table = $pntable['ce_xmlitems'];
		$xmlitems_column = &$pntable['ce_xmlitems_column'];

		$sql  = "SELECT $xmlitems_column[id], ";
		$sql .= "       $xmlitems_column[parent_id], ";
		$sql .= "       $xmlitems_column[title], ";
		$sql .= "       $xmlitems_column[content], ";
		$sql .= "       $xmlitems_column[type], ";
		$sql .= "       $xmlitems_column[language], ";
		$sql .= "       $xmlitems_column[status], ";
		$sql .= "       $xmlitems_column[xslt] ";
		$sql .= "FROM $xmlitems_table ";
		$sql .= "WHERE 1";
		$sql .= " AND ($xmlitems_column[id] = $xsltid) ";

		if( isset( $status ) && !empty( $status )) 
		{
			$sql .= " AND ($xmlitems_column[status] = '".pnVarPrepForStore($status)."') ";;
		}
		// If current status is provided, then use it to restrict result set

		$result = $dbconn->Execute($sql);

		if ($dbconn->ErrorNo() != 0) {
			return $item;
		}
		list($id, $parent_id, $title, $content, $type, $language, $status) = $result->fields;

		if( pnSecAuthAction( 0, 'ContentExpress::XML', "$xmlid::", ACCESS_READ )) 
		{
			$item = array('id' => $id,
				'parent_id' => $parent_id,
				'title' =>$title,
				'content' => $content,
				'type'=>$type,
				'language' => $language,
				'status' => $status);
		}
		$result->Close();
		return $item;
	}

	function api_getall($args)
	{
		extract($args);
		$items = array();

		if (!pnSecAuthAction(0, 'ContentExpress::XML', '::', ACCESS_READ)) 
		{
			return $items;
		}
		$dbtype = pnConfigGetVar('dbtype');
		list($dbconn) = pnDBGetConn();
		$pntable = pnDBGetTables();

		$xmlitems_table = $pntable['ce_xmlitems'];
		$xmlitems_column = &$pntable['ce_xmlitems_column'];

		$sql  = "SELECT $xmlitems_column[id], ";
		$sql .= "       $xmlitems_column[parent_id], ";
		$sql .= "       $xmlitems_column[title], ";
		$sql .= "       $xmlitems_column[content], ";
		$sql .= "       $xmlitems_column[type], ";
		$sql .= "       $xmlitems_column[language], ";
		$sql .= "       $xmlitems_column[status], ";
		$sql .= "       $xmlitems_column[xslt] ";
		$sql .= "FROM $xmlitems_table ";
		$sql .= "WHERE 1";

		if($type == "2")
		{
			$sql .= " AND ($xmlitems_column[type] = 2) ";
		}
		else
		{
			$sql .= " AND ($xmlitems_column[type] = 1) ";
		}

		if( isset( $status ) && !empty( $status )) 
		{
			$sql .= " AND ($xmlitems_column[status] = '".pnVarPrepForStore($status)."') ";;
		}

		if( isset( $xslt ) && !empty( $xslt )) 
		{
			$sql .= " AND ($xmlitems_column[xslt] = '".pnVarPrepForStore($xslt)."') ";;
		}

		$result = $dbconn->Execute($sql);
		if ($dbconn->ErrorNo() != 0) 
		{
			return $items;
		}
        
		for (; !$result->EOF; $result->MoveNext()) 
		{
			list($id, $parent_id, $title, $content, $type, $language, $status,$xslt) = $result->fields;

			if( pnSecAuthAction( 0, 'ContentExpress::XML', "$xmlid::", ACCESS_READ )) 
			{
				$items[] = array('id' => $id,
					'parent_id' => $parent_id,
					'title' => $title,
					'content' => $content,
					'type'=>$type,
					'language' => $language,
					'status' => $status,
					'xslt'=>$xslt);
			}
		}
		$result->Close();
		return $items;
	}

	function api_insert($args)
	{
		extract($args);
		if (!pnModAPILoad('ContentExpress', 'user'))
		{
			pnSessionSetVar('errormsg', _LOADFAILED);
			return false;
		}

		/*if (!pnSecAuthAction(0, 'ContentExpress::Content', "$xmlid::", ACCESS_EDIT))
		{
			pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
			return false;
		}*/
		list($dbconn) = pnDBGetConn();
		$pntable = pnDBGetTables();
		$dbtype = pnConfigGetVar('dbtype');

		$xml_table = $pntable['ce_xmlitems'];
		$xml_column = &$pntable['ce_xmlitems_column'];

		$sql = "insert into $xml_table (";
		$sql .="$xml_column[parent_id], $xml_column[title],$xml_column[content],$xml_column[status], $xml_column[language], $xml_column[type], $xml_column[xslt]) ";
		$sql .="values ('".pnVarPrepForStore($parent_id)."' ,'".pnVarPrepForStore($title)."' ,'".pnVarPrepForStore($content)."' ,'".pnVarPrepForStore($status)."' ,'".pnVarPrepForStore($language)."' ,'".pnVarPrepForStore($xmltype)."' ,'".pnVarPrepForStore($xslt)."' );";
		//$sql .="where $xml_column[id] = '".pnVarPrepForStore($xmlid)."';";
		//echo $sql;
		$dbconn->Execute($sql);

		if ($dbconn->ErrorNo() != 0)
		{
			pnSessionSetVar('errormsg', _XML_CONTENT_APIUPDATEFAILED);
			return false;
		}
		return true;
		return true;
	}

	function api_update($args)
	{
		extract($args);
		if (!pnModAPILoad('ContentExpress', 'user'))
		{
			pnSessionSetVar('errormsg', _LOADFAILED);
			return false;
		}

		if (!pnSecAuthAction(0, 'ContentExpress::Content', "$xmlid::", ACCESS_EDIT))
		{
			pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
			return false;
		}
		list($dbconn) = pnDBGetConn();
		$pntable = pnDBGetTables();
		$dbtype = pnConfigGetVar('dbtype');

		$xml_table = $pntable['ce_xmlitems'];
		$xml_column = &$pntable['ce_xmlitems_column'];
		$content = pnVarPrepForStore($content);
		$content = ereg_replace(';@','@',$content);
		$sql = "update $xml_table ";
		$sql .="set $xml_column[parent_id] = '".pnVarPrepForStore($parent_id)."' ,";
		$sql .="$xml_column[title] = '".pnVarPrepForStore($title)."' ,";
		$sql .="$xml_column[content] = '$content' ,";
		$sql .="$xml_column[status] = '".pnVarPrepForStore($status)."' ,";
		$sql .="$xml_column[language] = '".pnVarPrepForStore($language)."' ,";
		$sql .="$xml_column[type] = '".pnVarPrepForStore($xmltype)."' ,";
		$sql .="$xml_column[xslt] = '".pnVarPrepForStore($xslt)."' ";
		$sql .="where $xml_column[id] = '".pnVarPrepForStore($xmlid)."';";

		$dbconn->Execute($sql);

		if ($dbconn->ErrorNo() != 0)
		{
			pnSessionSetVar('errormsg', _XML_CONTENT_APIUPDATEFAILED);
			return false;
		}
		return true;
	}

	function api_delete($args)
	{
		extract($args);
		if (!pnModAPILoad('ContentExpress', 'user'))
		{
			pnSessionSetVar('errormsg', _LOADFAILED);
			return false;
		}

		if (!pnSecAuthAction(0, 'ContentExpress::Content', "$xmlid::", ACCESS_EDIT))
		{
			pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
			return false;
		}
		if (pnModAPIFunc('ContentExpress',
                        'user',
                        'get_allxml',
                        array('xslt' => $xmlid)))
		{
			pnSessionSetVar('errormsg', _XMLCONTENT_DELETEDEPENCYFAILED);
			return false;
		}
		list($dbconn) = pnDBGetConn();
		$pntable = pnDBGetTables();
		$dbtype = pnConfigGetVar('dbtype');

		$xml_table = $pntable['ce_xmlitems'];
		$xml_column = &$pntable['ce_xmlitems_column'];

		$sql = "delete from $xml_table where $xml_column[id] = '".pnVarPrepForStore($xmlid)."';";
		$dbconn->Execute($sql);
		
		if ($dbconn->ErrorNo() != 0)
		{
			pnSessionSetVar('errormsg', _UPDATEFAILED);
			return false;
		}
		return true;
	}

	function admin_new($args)
	{
		$output = new pnCEHTML();
		if (!pnSecAuthAction(0, 'ContentExpress::XML', '::', ACCESS_ADD)) 
		{
			$output->Text(_XMLCONTENTNOAUTH);
			return $output->GetOutput();
		}

		if (!CommonExpress_checkxslt())
		{
			$output->Text(_CE_USER_XSLTNOTSUPPORTED);
			return $output->GetOutput();
		}

		$output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->Text(pnModFunc('ContentExpress', 'admin', 'adminmenu'));

		if (!pnModAPILoad('ContentExpress', 'user')) 
		{
			$output->Text(_LOADFAILED);
			return $output->GetOutput();
		}

		$items = pnModAPIFunc('ContentExpress',
                        'user',
                        'get_allxml',
                        array());
		$xslts = pnModAPIFunc('ContentExpress',
                        'user',
                        'get_allxml',
                        array('type'=>2));

		$output->LineBreak(2);
		if (!$items)
		{
			$output->Text(_XMLCONTENT_NOXMLITEMS);
		}
		
		$output->TableStart();
		$row = array();
		$output->SetOutputMode(_PNH_RETURNOUTPUT);
		$itemview = CommonExpress_display_themeable_anchor( $mytheme,
                                                       pnModURL( 'ContentExpress', 'admin', 'addxml',
                                                                 array()),
                                                       _XMLCONTENT_ADDXMLITEM, "Add" );
		$row[] = $output->Text($itemview);
		$output->SetOutputMode(_PNH_KEEPOUTPUT);
		$output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->TableAddrow($row, 'left');
		$output->SetInputMode(_PNH_PARSEINPUT);

		$output->TableEnd();
		//show table with xml items
		$output->TableStart('XML Items');
		$row = array();

		$output->SetOutputMode(_PNH_RETURNOUTPUT);
		$row[] = $output->BoldText(pnVarPrepForDisplay('id'));
		$row[] = $output->BoldText(pnVarPrepForDisplay('parent_id'));
		$row[] = $output->BoldText(pnVarPrepForDisplay('title'));
		//$row[] = $output->BoldText(pnVarPrepForDisplay('type'));
		$row[] = $output->BoldText(pnVarPrepForDisplay('language'));
		$row[] = $output->BoldText(pnVarPrepForDisplay('status'));
		$row[] = $output->BoldText(pnVarPrepForDisplay('xslt'));
		$row[] = $output->BoldText(pnVarPrepForDisplay(' '));
		$row[] = $output->BoldText(pnVarPrepForDisplay(' '));
		
		$output->SetOutputMode(_PNH_KEEPOUTPUT);
		$output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->TableAddrow($row, 'left');
		$output->SetInputMode(_PNH_PARSEINPUT);

		foreach($items as $id=>$item)
		{
			$row = array();
			$output->SetOutputMode(_PNH_RETURNOUTPUT);
			$row[] = $output->Text(pnVarPrepForDisplay($item['id']));
			$row[] = $output->Text($item['parent_id']);
			$row[] = $output->Text($item['title']);
			//$row[] = $output->Text($item['type']);
			$row[] = $output->Text($item['language']);
			if ($item['status']==1)
			{
				$row[] = $output->Text(_XMLCONTENT_ACTIVE);
			}
			else
			{
				$row[] = $output->Text(_XMLCONTENT_NOTACTIVE);
			}
			$row[] = $output->Text($item['xslt']);
			$output->SetInputMode(_PNH_VERBATIMINPUT);
			$itemview = CommonExpress_display_themeable_anchor( $mytheme,
                                                       pnModURL( 'ContentExpress', 'user', 'showxml',
                                                                 array( 'xmlid' => $item['id'] )),
                                                       _XMLCONTENT_VIEWXML, "View" );
			$itemedit = CommonExpress_display_themeable_anchor( $mytheme,
                                                       pnModURL( 'ContentExpress', 'admin', 'editxml',
                                                                 array( 'xmlid' => $item['id'] )),
                                                       _XMLCONTENT_EDITXML, "Edit" );
			//$row[] = $output->Text($itemedit);
			$itemdelete = CommonExpress_display_themeable_anchor( $mytheme,
                                                       pnModURL( 'ContentExpress', 'admin', 'deletexml',
                                                                 array( 'xmlid' => $item['id'] )),
                                                       _XMLCONTENT_DELETEXML, "Delete" );
			$row[] = $output->Text("$itemview $itemedit $itemdelete");
			$output->SetOutputMode(_PNH_KEEPOUTPUT);
			$output->SetInputMode(_PNH_VERBATIMINPUT);
			$output->TableAddrow($row, 'left');
			$output->SetInputMode(_PNH_PARSEINPUT);
		}
		$output->TableEnd();
		$output->Linebreak(2);
		
		//show table with xslt items
		$output->TableStart('XSLT Items');
		$row = array();
		$output->SetOutputMode(_PNH_RETURNOUTPUT);
		$row[] = $output->BoldText(pnVarPrepForDisplay('id'));
		//$row[] = $output->BoldText(pnVarPrepForDisplay('parent_id'));
		$row[] = $output->BoldText(pnVarPrepForDisplay('title'));
		//$row[] = $output->BoldText(pnVarPrepForDisplay('type'));
		$row[] = $output->BoldText(pnVarPrepForDisplay('language'));
		$row[] = $output->BoldText(pnVarPrepForDisplay('status'));
		//$row[] = $output->BoldText(pnVarPrepForDisplay('xslt'));
		$row[] = $output->BoldText(pnVarPrepForDisplay(' '));
		$row[] = $output->BoldText(pnVarPrepForDisplay(' '));
		$output->SetOutputMode(_PNH_KEEPOUTPUT);
		$output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->TableAddrow($row, 'left');
		$output->SetInputMode(_PNH_PARSEINPUT);

		foreach($xslts as $id=>$item){
			$row = array();
			$output->SetOutputMode(_PNH_RETURNOUTPUT);
			$row[] = $output->Text(pnVarPrepForDisplay($item['id']));
			//$row[] = $output->Text($item['parent_id']);
			$row[] = $output->Text($item['title']);
			//$row[] = $output->Text($item['type']);
			$row[] = $output->Text($item['language']);
			if ($item['status']==1){
				$row[] = $output->Text(_XMLCONTENT_ACTIVE);
			}
			else
			{
				$row[] = $output->Text(_XMLCONTENT_NOTACTIVE);
			}
			//$row[] = $output->Text($item['status']);
			//$row[] = $output->Text($item['xslt']);
			$output->SetInputMode(_PNH_VERBATIMINPUT);
			$itemedit = CommonExpress_display_themeable_anchor( $mytheme,
                                                       pnModURL( 'ContentExpress', 'admin', 'editxml',
                                                                 array( 'xmlid' => $item['id'] )),
                                                       _XMLCONTENT_EDITXML, "Edit" );
			//$row[] = $output->Text($itemedit);
			$itemdelete = CommonExpress_display_themeable_anchor( $mytheme,
                                                       pnModURL( 'ContentExpress', 'admin', 'deletexml',
                                                                 array( 'xmlid' => $item['id'] )),
                                                       _XMLCONTENT_DELETEXML, "Delete" );
			$row[] = $output->Text("$itemedit $itemdelete");
			$output->SetOutputMode(_PNH_KEEPOUTPUT);
			$output->SetInputMode(_PNH_VERBATIMINPUT);
			$output->TableAddrow($row, 'left');
			$output->SetInputMode(_PNH_PARSEINPUT);
		}
		$output->TableEnd();

		return $output->GetOutput();
	}
	
	function admin_buildform($item=0,$mode='')
	{
		//build the insert/edit form based on the $args
		//extract($args);
		$output = new pnCEHTML();
		if( empty( $item ))
		{
			$output->Text(_XMLCONTENT_NOCORRECTITEMSELECTED);
			return $output->GetOutput();
		}
		if (!pnModAPILoad('ContentExpress', 'user')) 
		{
			$output->Text(_LOADFAILED);
			return $output->GetOutput();
		}
		$xmls = pnModAPIFunc('ContentExpress',
			'user',
			'get_allxml',
			array('type'=>1));
		$xslts = pnModAPIFunc('ContentExpress',
			'user',
			'get_allxml',
			array('type'=>2));
		if ($mode<>'add')
		{
			$output->FormStart(pnModURL('ContentExpress', 'admin', 'updatexml'));
		}
		else
		{
			$output->FormStart(pnModURL('ContentExpress', 'admin', 'insertxml'));
		}
		$output->FormHidden('authid', pnSecGenAuthKey());
		$output->FormHidden('xmlid', $item['id']);
		$output->TableStart( "", "", 0, "100%", 0, 0 );

		//parent_id
		$row = array();
		$xmllist = array();
		foreach ($xmls as $id=>$listitem)
		{
			if ($listitem['id'] <> $item['id'])
			{
				$xmllist[] = array('id'=>$listitem['id'],'title'=>$listitem['title']);
			}
		}
		$parentxmllist = array();
		$parentxmllist[] = array('id'=>-1,'selected'=>0,'name'=>_XMLCONTENT_XMLNOPARENT);
		foreach ($xmllist as $id=>$listitem)
		{
			if ($listitem['id'] == $item['parent_id'])
			{
				$parentxmllist[] = array('id'=>$listitem['id'],'selected'=>1,'name'=>$listitem['title']);
			}
			else
			{
				$parentxmllist[] = array('id'=>$listitem['id'],'selected'=>0,'name'=>$listitem['title']);
			}
		}
		$output->SetOutputMode(_PNH_RETURNOUTPUT);
		$row[] = $output->Text(pnVarPrepForDisplay(_XMLCONTENT_XMLPARENT));
		$row[] = $output->FormSelectMultiple('parent_id', $parentxmllist , 0, 1, $item['parent_id'] );
		$output->SetOutputMode(_PNH_KEEPOUTPUT);
		$output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->TableAddrow($row, 'left');
		$output->SetInputMode(_PNH_PARSEINPUT);

		//title
		$row = array();
		$output->SetOutputMode(_PNH_RETURNOUTPUT);
		$row[] = $output->Text(pnVarPrepForDisplay(_XMLCONTENT_XMLTITLE));
		$row[] = $output->FormText('title', pnVarPrepForDisplay($item['title']), 32, 256);
		$output->SetOutputMode(_PNH_KEEPOUTPUT);
		$output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->TableAddrow($row, 'left');
		$output->SetInputMode(_PNH_PARSEINPUT);

		//content
		$row = array();
		$output->SetOutputMode(_PNH_RETURNOUTPUT);
		$row[] = $output->Text(pnVarPrepForDisplay(_XMLCONTENT_XMLCONTENT));
		$row[] = $output->FormTextArea('content', $item['content'], 40, 100);
		$output->SetOutputMode(_PNH_KEEPOUTPUT);
		$output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->TableAddrow($row, 'left');
		$output->SetInputMode(_PNH_PARSEINPUT);

		//type
		$types = array('1'=>'XML','2'=>'XSLT');
		$selecttypes = array();
		$row = array();
		$output->SetOutputMode(_PNH_RETURNOUTPUT);
		$row[] = $output->Text(pnVarPrepForDisplay(_XMLCONTENT_XMLTYPE));
		foreach ($types as $t=>$typetext)
		{
			if ($t== $item['type'])
			{
				$selecttypes[] = array('id'=>$t,'selected'=>1,'name'=>$typetext);
			}
			else
			{
				$selecttypes[] = array('id'=>$t,'selected'=>0,'name'=>$typetext);
			}
		}

		$row[] = $output->FormSelectMultiple('xmltype', $selecttypes, 0, 1, $item['type'] );

		$output->SetOutputMode(_PNH_KEEPOUTPUT);
		$output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->TableAddrow($row, 'left');
		$output->SetInputMode(_PNH_PARSEINPUT);

		// Language
		$output->TableRowStart();
		$languages = languagelist();
		$langs = array();
		$langs[] = array( 'id' => 'x_all', 'selected' => 0, 'name' => 'All' );
		foreach( $languages as $l => $lan ) 
		{
			if( $l == $item['language'] ) 
			{
				$langs[] = array( 'id' => $l, 'selected' => 1, 'name' => $lan );
			}
			else 
			{
				$langs[] = array( 'id' => $l, 'selected' => 0, 'name' => $lan );
			}
		}

		$output->TableColStart( 1, 'left' );

		$output->Text(pnVarPrepForDisplay(_MENUCONTENTCONTENTLANG));
		$output->TableColEnd();
		$output->TableColStart( 1, 'left' );
		if( $item != 0 && !empty( $item )) 
		{
			$output->FormSelectMultiple('language', $langs, 0, 1, $item['language'] );
		}
		else
		{
			$output->FormSelectMultiple('language', $langs );
		}
		$output->TableColEnd();

		//status
		$row = array();
		$status = array('1'=>_XMLCONTENT_ACTIVE,'0'=>_XMLCONTENT_NOTACTIVE);
		$selectstatus = array();
		foreach ($status as $s=>$statustext)
		{
			if ($s== $item['status'])
			{
				$selectstatus[] = array('id'=>$s,'selected'=>1,'name'=>$statustext);
			}
			else
			{
				$selectstatus[] = array('id'=>$s,'selected'=>0,'name'=>$statustext);
			}
		}
		$output->SetOutputMode(_PNH_RETURNOUTPUT);
		$row[] = $output->Text(pnVarPrepForDisplay(_XMLCONTENT_XMLSTATUS));
		$row[] = $output->FormSelectMultiple('status', $selectstatus, 0, 1, $item['status'] );
		$output->SetOutputMode(_PNH_KEEPOUTPUT);
		$output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->TableAddrow($row, 'left');
		$output->SetInputMode(_PNH_PARSEINPUT);

		//xslt
		$row = array();
		$xsltlist = array();
		foreach ($xslts as $id=>$listitem)
		{
			$xsltlist[] = array('id'=>$listitem['id'],'title'=>$listitem['title']);
		}
		$parentxsltlist = array();
		foreach ($xsltlist as $id=>$listitem)
		{
			if ($listitem['id'] == $item['xslt'])
			{
				$parentxsltlist[] = array('id'=>$listitem['id'],'selected'=>1,'name'=>$listitem['title']);
			}
			else
			{
				$parentxsltlist[] = array('id'=>$listitem['id'],"selected"=>0,'name'=>$listitem['title']);
			}
		}
		$output->SetOutputMode(_PNH_RETURNOUTPUT);
		$row[] = $output->Text(pnVarPrepForDisplay(_XMLCONTENT_XMLXSLT));
		$row[] = $output->FormSelectMultiple('xslt', $parentxsltlist , 0, 1, $item['xslt'] );
		$output->SetOutputMode(_PNH_KEEPOUTPUT);
		$output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->TableAddrow($row, 'left');
		$output->SetInputMode(_PNH_PARSEINPUT);

		$output->TableEnd();
		$output->FormSubmit(_MENUCONTENTUPDATEXML);
		$output->FormEnd();
		return $output->GetOutput();
	}
	
	function admin_add($args)
	{
		$args['mode'] = 'add';
		return $this->admin_edit($args);
	}
	
	function admin_edit($args)
	{
		$xmlid = pnVarCleanFromInput('xmlid');
		extract($args);
		$output = new pnCEHTML();
		if (!pnSecAuthAction(0, 'ContentExpress::XML', '::', ACCESS_ADD)) 
		{
			$output->Text(_XMLCONTENTNOAUTH);
			return $output->GetOutput();
		}
		if (!pnModAPILoad('ContentExpress', 'user')) 
		{
			$output->Text(_LOADFAILED);
			return $output->GetOutput();
		}
		if ($mode<>"add")
		{
			$item = pnModAPIFunc('ContentExpress',
				'user',
				'get_xmlitem',
				array('xmlid' => $xmlid));
		}
		else
		{
			$item = array('xmlid'=>0);
		}
		$output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->Text(pnModFunc('ContentExpress', 'admin', 'adminmenu'));
		$output->SetInputMode(_PNH_PARSEINPUT);
		$output->LineBreak(2);
		$form = $this->admin_buildform($item,$mode);
		$output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->Text($form);
		$output->SetInputMode(_PNH_PARSEINPUT);
		return $output->GetOutput();
	}

	function admin_insert($args)
	{
		list($xmlid,$parent_id, $title, $content, $xmltype, $language, $status, $xslt) = 
		pnVarCleanFromInput('xmlid','parent_id','title','content','xmltype','language','status','xslt');
		extract($args);
		if (!pnSecConfirmAuthKey()) 
		{
			pnSessionSetVar('errormsg', _BADAUTHKEY);
			return pnRedirect(pnModURL('ContentExpress', 'admin', 'addxml',array() ));
		}
		if (!pnModAPILoad('ContentExpress', 'admin')) 
		{
			$output = new pnCEHTML();
			pnSessionSetVar('errormsg', _LOADFAILED);
			return $output->GetOutput();
		}

		if(pnModAPIFunc('ContentExpress',
			'admin',
			'insertxml',
			array(	'parent_id' => $parent_id,
				'title' => $title,
				'content' => $content,
				'xmltype'=>$xmltype,
				'language' => $language,
				'status' => $status,
				'xslt'=>$xslt)))
		{
			pnSessionSetVar('statusmsg', _XMLCONTENT_XMLINSERTED);
		}
		return pnRedirect(pnModURL('ContentExpress', 'admin', 'newxml'));	
	}
	
	function admin_update()
	{
		list($xmlid,$parent_id, $title, $content, $xmltype, $language, $status, $xslt) = 
			pnVarCleanFromInput('xmlid','parent_id','title','content','xmltype','language','status','xslt');
		extract($args);
		if (!pnSecConfirmAuthKey()) 
		{
			pnSessionSetVar('errormsg', _BADAUTHKEY);
			return pnRedirect(pnModURL('ContentExpress', 'admin', 'editxml',array('xmlid' => $id) ));
		}
		if (!pnModAPILoad('ContentExpress', 'admin')) 
		{
			pnSessionSetVar('errormsg', _LOADFAILED);
			return $output->GetOutput();
		}

		if(pnModAPIFunc('ContentExpress',
			'admin',
			'updatexml',
			array('xmlid' => $xmlid,
				'parent_id' => $parent_id,
				'title' => $title,
				'content' => $content,
				'xmltype'=>$xmltype,
				'language' => $language,
				'status' => $status,
				'xslt'=>$xslt)))
		{
			pnSessionSetVar('statusmsg', _XMLCONTENT_XMLUPDATED);
		}
		return pnRedirect(pnModURL('ContentExpress', 'admin', 'newxml'));
	}

	function admin_delete($args)
	{
		list ($xmlid) = pnVarCleanFromInput('xmlid');
		extract($args);
		if (!pnModAPILoad('ContentExpress', 'admin')) 
		{
			pnSessionSetVar('errormsg', _LOADFAILED);
			return $output->GetOutput();
		}
		$output = new pnCEHTML();
		if (!pnSecAuthAction(0, 'ContentExpress::XML', '::', ACCESS_ADD)) 
		{
			$output->Text(_XMLCONTENTNOAUTH);
			return $output->GetOutput();
		}
		$output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->Text(pnModFunc('ContentExpress', 'admin', 'adminmenu'));
		$output->SetInputMode(_PNH_PARSEINPUT);
		$output->LineBreak(2);
		if (pnModAPIFunc('ContentExpress',
			'admin',
			'deletexml',
			array('xmlid' => $xmlid)))
		{
			pnSessionSetVar('statusmsg', _XMLCONTENT_XMLDELETED);
		}
		return pnRedirect(pnModURL('ContentExpress', 'admin', 'newxml'));
	}

	function admin_modifyxmlconfig()
	{
		$output = new pnCEHTML();
		if (!pnSecAuthAction(0, 'ContentExpress::XML', '::', ACCESS_ADD)) 
		{
			$output->Text(_XMLCONTENTNOAUTH);
			return $output->GetOutput();
		}
		if (!CommonExpress_checkxslt())
		{
			$output->Text(_CE_USER_XSLTNOTSUPPORTED);
			return $output->GetOutput();
		}

		$output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->Text(pnModFunc('ContentExpress', 'admin', 'adminmenu'));
		$output->SetInputMode(_PNH_PARSEINPUT);
		$output->LineBreak(2);
		//$output->Text("We'll be offering xslt options here later.");
		//[ToDo] let XML Directory to be configured.
		$output->Title(_XMLCONTENTMODIFYXMLCONFIG);

		//Form Start
		$output->FormStart(pnModURL('ContentExpress', 'admin', 'updatexmlconfig'));

		$output->FormHidden('authid', pnSecGenAuthKey());
		$output->TableStart( "", "", 0, "100%", 0, 0 );

		$xml_directory = pnModGetVar('ContentExpress', 'xml_directory');

		//XML_directory
		$row = array();
		$output->SetOutputMode(_PNH_RETURNOUTPUT);
		$row[] = $output->Text(pnVarPrepForDisplay(_XMLCONTENTDIRECTORY));
		$row[] = $output->FormText('xml_directory', $xml_directory, 32, 256);
		$output->SetOutputMode(_PNH_KEEPOUTPUT);
		$output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->TableAddrow($row, 'left');
		$output->SetInputMode(_PNH_PARSEINPUT);

		// End form
		$output->TableEnd();
		$output->Linebreak(2);

		$output->FormSubmit(_MENUCONTENTUPDATECONFIG);
		$output->FormEnd();
		return $output->GetOutput();
	}

	function admin_updatexmlconfig($args)
	{
		$xml_directory = pnVarCleanFromInput('xml_directory');
		extract( $args );
		if (!pnSecConfirmAuthKey()) 
		{
			pnSessionSetVar('errormsg', _BADAUTHKEY);
			return pnRedirect(pnModURL('ContentExpress', 'admin', 'view'));
		}

		pnModSetVar('ContentExpress', 'xml_directory', $xml_directory);

		pnSessionSetVar('statusmsg', _XMLCONTENTCONFIGUPDATED);

		return pnRedirect(pnModURL('ContentExpress', 'admin', 'view'));
	}

	function user_display($args)
	{
		//include("./modules/ContentExpress/pnclass/debugarray.inc.php");
		$ModName = basename( dirname( dirname( __FILE__ )));
		list ($xmlid, $xmlfile,$xsltfile) = pnVarCleanFromInput('xmlid','xmlfile','xsltfile');
		extract($args);
		//putting the URI arguments into an array that'll be passed to the XSLT process
		$parameters = array();
		foreach($_REQUEST as $name=>$value)
		{
			$parameters[$name]=$value;
		}
		$path = "./modules/$ModName/";
		include("./modules/$ModName/pnclass/class_xslt.php");
		$output = new pnCEHTML();

		if (!pnModAPILoad('ContentExpress', 'user')) 
		{
			$output->Text(_LOADFAILED);
			return $output->GetOutput();
		}

		if (!CommonExpress_checkxslt())
		{
			$output->Text(_CE_USER_XSLTNOTSUPPORTED);
			return $output->GetOutput();
		}

		$xml_directory = pnModGetVar('ContentExpress', 'xml_directory');

		$output->SetInputMode(_PNH_VERBATIMINPUT);
		if (!$xmlfile&&!$xmlid)
		{ 
		//only display index when no XML is given
		//[ToDo]Redesign XML index
			$output->Text("<p>XML Directory content:</p>");
			$dir = $path.$xml_directory."/";
			$dircontent = CommonExpress_scanxmldir($dir);
			$output->Text($dircontent);
		}
		else
		{
			if ($xmlfile)//An XML file is given, we now transform it with its XSLT
			{
				if (!$xsltfile)
				{
					$output->Text(_CE_USER_XSLTFILENOTGIVEN);
					return $output->GetOutput();
				}
				$xslt=new Xslt();
				$xslt->setXML($path.$xml_directory."/".$xmlfile);
				$xslt->setXsl($path.$xml_directory."/".$xsltfile);
			}
			elseif($xmlid)
			{
				$item = pnModAPIFunc('ContentExpress',
					'user',
					'get_xmlitem',
					array('xmlid' => $xmlid));
					//Now that we have the related xslt id we can fetch also that one.
					if (!$item["xslt"]==0)
					{
						// when the xmlid's xslt is 0 then the xml is a xslt itself or an xml file without given xslt
						$itemxslt = pnModAPIFunc('ContentExpress',
							'user',
							'get_xsltitem',
							array('xsltid' => $item["xslt"]));
					}
					else
					{
						$output->Text(_CE_USER_ISNOVALIDXSLTFORXML);
						return $output->GetOutput();
					}
					$xslt=new Xslt();
					$xslt->setXmlString($item["content"]);
					$xslt->setXslString($itemxslt["content"]);
			}
			if($xslt->transform($parameters)) 
			{
				$ret=$xslt->getOutput();
				$output->Text("<link title=\"new\" rel=\"stylesheet\" href=\"./modules/$ModName/includes/main.css\" type=\"text/css\"/>");
    				list($ret) = pnModCallHooks('item', 'transform', '', array($ret));
				$output->Text($ret);
			}
			else
			{
				$output->Text("Error:".$xslt->getError());
			}
		}
		return $output->GetOutput();
	}
	
}